/**
 * Tel-Aviv University
 * Software 1 
 *  
 */

import java.util.Arrays;

public class ArrayAndStringUtilsDemo {

	public static void main(String[] args) {

		System.out.println("ARRAYS -----------------------------------");

		System.out.println("\nreverseArray:");
		int[] array1 = { 1, 2, 3, 4, 5, 6, 7, 8 };
		int[] revArray = ArrayUtils.reverseArray(array1);
		System.out.println(Arrays.toString(array1));
		System.out.println("->");
		System.out.println(Arrays.toString(revArray));

		System.out.println("\nfillStringArray:");
		String[] strArray = { "aa", "bb", "cc", "dd" };
		int[] repeats = { 1, 2, 3, 4 };
		String[] filledArray = ArrayUtils.fillStringArray(strArray, repeats);
		System.out.println(Arrays.toString(strArray));
		System.out.println(Arrays.toString(repeats));
		System.out.println("->");
		System.out.println(Arrays.toString(filledArray));

		System.out.println("");
		String[] strArray2 = { "And", "I", "Will always love", "You" };
		int[] repeats2 = { 1, 3, 1, 2 };
		String[] filledArray2 = ArrayUtils.fillStringArray(strArray2, repeats2);
		System.out.println(Arrays.toString(strArray2));
		System.out.println(Arrays.toString(repeats2));
		System.out.println("->");
		System.out.println(Arrays.toString(filledArray2));

		System.out.println("\ntransposeMatrix:");
		int[][] mat = { { 1, 2, 3, 4 }, { 5, 6, 7, 8 }, { 9, 10, 11, 12 } };
		int[][] transposedMat = ArrayUtils.transposeMatrix(mat);
		for (int[] row : mat)
			System.out.println(Arrays.toString(row));
		System.out.println("->");
		for (int[] row : transposedMat)
			System.out.println(Arrays.toString(row));

		System.out.println("\nsplitArrayByNum:");
		int[] intArray1 = { 1, 2, 3, 1, 2, 3, 1, 1, 2, 2, 3, 1 };
		int[][] splitArray1 = ArrayUtils.splitArrayByNum(intArray1, 3);
		System.out.println(Arrays.toString(intArray1) + " -> ");
		for (int i = 0; i < splitArray1.length; i++)
			System.out.println(Arrays.toString(splitArray1[i]));

		int[] intArray2 = { 3, 1, 3, 3 };
		int[][] splitArray2 = ArrayUtils.splitArrayByNum(intArray2, 3);
		System.out.println("\n" + Arrays.toString(intArray2) + " -> ");
		for (int i = 0; i < splitArray2.length; i++) {
			System.out.println(Arrays.toString(splitArray2[i]));
		}

		System.out.println("\nmatrixMean:");
		System.out.println("\nMatrix initialization:");
		int[][] mat2 = { { 1, 2, 3 }, { 4, 5, 6 }, { 7, 8, 9 } };
		for (int[] row : mat2)
			System.out.println(Arrays.toString(row));

		System.out.println("Mean of matrix elements is "
				+ ArrayUtils.matrixMean(mat2));

		System.out.println("\n\nSTRINGS -----------------------------------\n");

		System.out.println("\nisPalindrome:");
		String s2 = "abcde";
		System.out.println(s2 + "  is "
				+ (StringUtils.isPalindrome(s2) ? "" : " not")
				+ " a palindrome.");

		String s3 = "abccba";
		System.out.println(s3 + "  is "
				+ (StringUtils.isPalindrome(s3) ? "" : " not")
				+ " a palindrome.");

		System.out.println("\nsortStringWords:");
		String sentence1 = "This is a test string which shall be used to demonstrate this method";
		System.out.println(sentence1 + " -> "
				+ StringUtils.sortStringWords(sentence1));
		String sentence2 = "To Be Or Not To Be";
		System.out.println(sentence2 + " -> "
				+ StringUtils.sortStringWords(sentence2));

		System.out.println("\nisStringArraySorted:");
		String[] sortedStrs = { "Alpha", "bravo", "Charlie", "Delta", "Echo" };
		System.out.println(Arrays.toString(sortedStrs) + ", 4 -> isSorted? - "
				+ StringUtils.isStringArraySorted(sortedStrs, 4));
		String[] unsortedStrs = { "Bravo", "Alpha", "Charlie", "Delta", "Echo" };
		System.out.println(Arrays.toString(unsortedStrs)
				+ ", 4  -> isSorted? - "
				+ StringUtils.isStringArraySorted(unsortedStrs, 4));
		String[] prefixSortedStrs = { "aaaC", "aaaB", "BBBb", "BBBa", "CCC" };
		System.out.println(Arrays.toString(prefixSortedStrs)
				+ ", 3-> isSorted? - "
				+ StringUtils.isStringArraySorted(prefixSortedStrs, 3));

		System.out.println("\nstringHistogram :");
		String s4 = "abbcccddddeeeeezzzzzzz";
		int[] hist1 = StringUtils.stringHistogram(s4);
		System.out.println(s4 + " -> " + Arrays.toString(hist1));

		String s5 = "mississippi";
		int[] hist2 = StringUtils.stringHistogram(s5);
		System.out.println(s5 + " -> " + Arrays.toString(hist2));

		System.out.println("\nAnagrams:");
		String a = "Debit Card";
		String b = "Bad Credit";
		System.out.println(a + " and " + b + " are "
				+ (StringUtils.areAnagrams(a, b) ? "" : "not ") + "anagrams.");
		a = "A decimal point";
		b = "Im a dot in place";
		System.out.println(a + " and " + b + " are "
				+ (StringUtils.areAnagrams(a, b) ? "" : "not ") + "anagrams.");
		a = "Election results";
		b = "Lies lets recount";
		System.out.println(a + " and " + b + " are "
				+ (StringUtils.areAnagrams(a, b) ? "" : "not ") + "anagrams.");
		a = "Debit Card";
		b = "Bad Rabit";
		System.out.println(a + " and " + b + " are "
				+ (StringUtils.areAnagrams(a, b) ? "" : "not ") + "anagrams.");

	}
}
